// NamePipeClientView.cpp : CNamePipeClientView ʵ
//

#include "stdafx.h"
#include "NamePipeClient.h"

#include "NamePipeClientDoc.h"
#include "NamePipeClientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CNamePipeClientView

IMPLEMENT_DYNCREATE(CNamePipeClientView, CView)

BEGIN_MESSAGE_MAP(CNamePipeClientView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_CONNECT, &CNamePipeClientView::OnConnect)
	ON_COMMAND(ID_READ, &CNamePipeClientView::OnRead)
	ON_COMMAND(ID_WRITE, &CNamePipeClientView::OnWrite)
END_MESSAGE_MAP()

// CNamePipeClientView /

CNamePipeClientView::CNamePipeClientView()
{
	// TODO: ڴ˴ӹ
	m_hPipe = NULL;
}

CNamePipeClientView::~CNamePipeClientView()
{
	if(!m_hPipe)
		CloseHandle(m_hPipe);
}

BOOL CNamePipeClientView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CNamePipeClientView 

void CNamePipeClientView::OnDraw(CDC* /*pDC*/)
{
	CNamePipeClientDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CNamePipeClientView ӡ

BOOL CNamePipeClientView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CNamePipeClientView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CNamePipeClientView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CNamePipeClientView 

#ifdef _DEBUG
void CNamePipeClientView::AssertValid() const
{
	CView::AssertValid();
}

void CNamePipeClientView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CNamePipeClientDoc* CNamePipeClientView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNamePipeClientDoc)));
	return (CNamePipeClientDoc*)m_pDocument;
}
#endif //_DEBUG


// CNamePipeClientView Ϣ

void CNamePipeClientView::OnConnect()
{
	if(!WaitNamedPipe("\\\\.\\pipe\\MyPipe", NMPWAIT_WAIT_FOREVER))
	{
		MessageBox("ǰûпõܵʵ");
		return;
	}
	m_hPipe = CreateFile("\\\\.\\pipe\\MyPipe", GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(m_hPipe == INVALID_HANDLE_VALUE)
	{
		MessageBox("ܵʧ");
		m_hPipe = NULL;
		return;
	}
}

void CNamePipeClientView::OnRead()
{
	char buf[100];
	DWORD dwRead;
	if(!ReadFile(m_hPipe, buf, 100, &dwRead, NULL))
	{
		MessageBox("ȡʧ");
		return;
	}
	MessageBox(buf);
}

void CNamePipeClientView::OnWrite()
{
	char buf[] = "client's data";
	DWORD dwWrite;
	if(!WriteFile(m_hPipe, buf, strlen(buf) + 1, &dwWrite, NULL))
	{
		MessageBox("дʧ");
		return;
	}
}
