// NamePipeSrvView.cpp : CNamePipeSrvView ʵ
//

#include "stdafx.h"
#include "NamePipeSrv.h"

#include "NamePipeSrvDoc.h"
#include "NamePipeSrvView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CNamePipeSrvView

IMPLEMENT_DYNCREATE(CNamePipeSrvView, CView)

BEGIN_MESSAGE_MAP(CNamePipeSrvView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_READ, &CNamePipeSrvView::OnRead)
	ON_COMMAND(ID_WRITE, &CNamePipeSrvView::OnWrite)
	ON_COMMAND(ID_CREATE, &CNamePipeSrvView::OnCreate)
END_MESSAGE_MAP()

// CNamePipeSrvView /

CNamePipeSrvView::CNamePipeSrvView()
{
	m_hPipe = NULL;

}

CNamePipeSrvView::~CNamePipeSrvView()
{
	if(!m_hPipe)
		CloseHandle(m_hPipe);
}

BOOL CNamePipeSrvView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CNamePipeSrvView 

void CNamePipeSrvView::OnDraw(CDC* /*pDC*/)
{
	CNamePipeSrvDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CNamePipeSrvView ӡ

BOOL CNamePipeSrvView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CNamePipeSrvView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CNamePipeSrvView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CNamePipeSrvView 

#ifdef _DEBUG
void CNamePipeSrvView::AssertValid() const
{
	CView::AssertValid();
}

void CNamePipeSrvView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CNamePipeSrvDoc* CNamePipeSrvView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNamePipeSrvDoc)));
	return (CNamePipeSrvDoc*)m_pDocument;
}
#endif //_DEBUG


// CNamePipeSrvView Ϣ

void CNamePipeSrvView::OnRead()
{
	char buf[100];
	DWORD dwRead;
	if(!ReadFile(m_hPipe, buf, 100, &dwRead, NULL))
	{
		MessageBox("ȡʧ");
		return;
	}
	MessageBox(buf);
}

void CNamePipeSrvView::OnWrite()
{
	char buf[] = "server's data";
	DWORD dwWrite;
	if(!WriteFile(m_hPipe, buf, strlen(buf) + 1, &dwWrite, NULL))
	{
		MessageBox("дʧ");
		return;
	}
}

void CNamePipeSrvView::OnCreate()
{
	m_hPipe = CreateNamedPipe("\\\\.\\pipe\\MyPipe", PIPE_ACCESS_DUPLEX | FILE_FLAG_OVERLAPPED, 0, 1, 1024, 1024, 0, NULL);
	if(INVALID_HANDLE_VALUE == m_hPipe)
	{
		MessageBox("ܵʧ");
		m_hPipe = NULL;
		return;
	}
	//ܵɹ, ȵȿͻ
	HANDLE hEvent;
	hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!hEvent)
	{
		MessageBox("¼ʧ");
		CloseHandle(m_hPipe);
		m_hPipe = NULL;
		return;
	}
	OVERLAPPED ovrlap;
	ZeroMemory(&ovrlap, sizeof(OVERLAPPED));
	ovrlap.hEvent = hEvent;
	//˵ȵȿͻ˵ܵ ConnectNamedPipe(ȡ)
	if(!ConnectNamedPipe(m_hPipe, &ovrlap))
	{
		if(GetLastError() != ERROR_IO_PENDING) //δĲ, һٲ
		{
			MessageBox("ȴͻʧ");
			CloseHandle(m_hPipe);
			CloseHandle(hEvent);
			m_hPipe = NULL;
			return;
		}
	}
	if(WAIT_FAILED == WaitForSingleObject(hEvent, INFINITE))
	{
		MessageBox("ȴʧ");
		CloseHandle(m_hPipe);
		CloseHandle(hEvent);
		m_hPipe = NULL;
		return;
	}
	CloseHandle(hEvent);
}
