// PipeView.cpp : CPipeView ʵ
//

#include "stdafx.h"
#include "Pipe.h"

#include "PipeDoc.h"
#include "PipeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPipeView

IMPLEMENT_DYNCREATE(CPipeView, CView)

BEGIN_MESSAGE_MAP(CPipeView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_WRITE, &CPipeView::OnWrite)
	ON_COMMAND(ID_READ, &CPipeView::OnRead)
	ON_COMMAND(ID_CREATE, &CPipeView::OnCreate)
END_MESSAGE_MAP()

// CPipeView /

CPipeView::CPipeView()
{
	// TODO: ڴ˴ӹ
	m_hRead = NULL;
	m_hWrite = NULL;
}

CPipeView::~CPipeView()
{
	if(m_hRead)
		CloseHandle(m_hRead);
	if(m_hWrite)
		CloseHandle(m_hWrite);
}

BOOL CPipeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CPipeView 

void CPipeView::OnDraw(CDC* /*pDC*/)
{
	CPipeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CPipeView ӡ

BOOL CPipeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CPipeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CPipeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CPipeView 

#ifdef _DEBUG
void CPipeView::AssertValid() const
{
	CView::AssertValid();
}

void CPipeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPipeDoc* CPipeView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPipeDoc)));
	return (CPipeDoc*)m_pDocument;
}
#endif //_DEBUG


// CPipeView Ϣ

void CPipeView::OnWrite()
{
	char buf[] = "test data";
	DWORD dwWrite;
	if(!WriteFile(m_hWrite, buf, strlen(buf) + 1, &dwWrite, NULL))
	{
		MessageBox("дʧ");
		return;
	}
}

void CPipeView::OnRead()
{
	char buf[100];
	DWORD dwRead;
	if(!ReadFile(m_hRead, buf, 100, &dwRead, NULL))
	{
		MessageBox("ȡʧ");
		return;
	}
	MessageBox(buf);
}

void CPipeView::OnCreate()
{
	SECURITY_ATTRIBUTES sa;
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = NULL;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	if(!CreatePipe(&m_hRead, &m_hWrite, &sa, 0))
	{
		MessageBox("ܵʧ");
		return;
	}
	STARTUPINFO sui;
	PROCESS_INFORMATION pi;
	//memset(sui, 0, sizeof(sui));
	ZeroMemory(&sui, sizeof(STARTUPINFO));
	//ӽʱҪѹܵݸӽ
	sui.cb = sizeof(STARTUPINFO);
	sui.dwFlags = STARTF_USESTDHANDLES;
	sui.hStdInput = m_hRead;
	sui.hStdOutput = m_hWrite;
	sui.hStdError = GetStdHandle(STD_ERROR_HANDLE);
	if(!CreateProcess("PipeChild.exe", NULL, NULL, NULL, TRUE, 0, NULL, NULL, &sui, &pi))
	{
		MessageBox("ӽʧ");
		CloseHandle(m_hRead);
		CloseHandle(m_hWrite);
		m_hRead = NULL;
		m_hWrite = NULL;
		return;
	}
	else
	{
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}
}
