// PipeChildView.cpp : CPipeChildView ʵ
//

#include "stdafx.h"
#include "PipeChild.h"

#include "PipeChildDoc.h"
#include "PipeChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPipeChildView

IMPLEMENT_DYNCREATE(CPipeChildView, CView)

BEGIN_MESSAGE_MAP(CPipeChildView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_READ, &CPipeChildView::OnRead)
	ON_COMMAND(ID_WRITE, &CPipeChildView::OnWrite)
END_MESSAGE_MAP()

// CPipeChildView /

CPipeChildView::CPipeChildView()
{
	// TODO: ڴ˴ӹ
	m_hRead = NULL;
	m_hWrite = NULL;
}

CPipeChildView::~CPipeChildView()
{
	if(m_hRead)
		CloseHandle(m_hRead);
	if(m_hWrite)
		CloseHandle(m_hWrite);
}

BOOL CPipeChildView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CPipeChildView 

void CPipeChildView::OnDraw(CDC* /*pDC*/)
{
	CPipeChildDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CPipeChildView ӡ

BOOL CPipeChildView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CPipeChildView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CPipeChildView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CPipeChildView 

#ifdef _DEBUG
void CPipeChildView::AssertValid() const
{
	CView::AssertValid();
}

void CPipeChildView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPipeChildDoc* CPipeChildView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPipeChildDoc)));
	return (CPipeChildDoc*)m_pDocument;
}
#endif //_DEBUG


// CPipeChildView Ϣ

void CPipeChildView::OnRead()
{
	char buf[100];
	DWORD dwRead;
	if(!ReadFile(m_hRead, buf, 100, &dwRead, NULL))
	{
		MessageBox("ȡʧ");
		return;
	}
	MessageBox(buf);
}

void CPipeChildView::OnWrite()
{
	char buf[] = "ܵ";
	DWORD dwWrite;
	if(!WriteFile(m_hWrite, buf, strlen(buf) + 1, &dwWrite, NULL))
	{
		MessageBox("дʧ");
		return;
	}
}

void CPipeChildView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
	m_hRead = GetStdHandle(STD_INPUT_HANDLE);
	m_hWrite = GetStdHandle(STD_OUTPUT_HANDLE);
}
